//
// Client-Applet for Miss Connectivity
//
// EAI and TCP/IP Testprogram
// VRML EAI (External Authoring Interface)
// Stephan Diehl (diehl@cs.uni-sb.de), March 1998
// first version written on vacation on Fuerteventura Island

// Java APIs
import java.applet.*;
import java.awt.*;
import java.util.*;
import java.net.*;
import java.io.*;

// VRML APIs
import vrml.external.Node;
import vrml.external.Browser;
//import vrml.external.field.*;
//import vrml.external.exception.*;
import vrml.external.field.FieldTypes;
import vrml.external.field.EventOutObserver;
import vrml.external.field.EventOut;
import vrml.external.field.EventOutMFNode;
import vrml.external.field.EventOutSFNode;
import vrml.external.field.EventOutSFTime;
import vrml.external.field.EventOutMFString;
import vrml.external.field.EventInMFString;
import vrml.external.field.EventInSFNode;

import vrml.external.exception.InvalidNodeException;

// LiveConnect for Netscape Navigator
// import netscape.javascript.JSObject;

public class StatueApplet extends Applet 
implements EventOutObserver,  // to register callback method with VRML-Plugin
           MUTech             // for argument type of UpdateThread
{
  public Browser browser;  // Browser we're using
  Node statue;             // Root of the scene graph (to which we add our clumps)
  Node[] parts;                // nodes of the statue
  EventInMFString[] geostrIn;  // we also store all events we need once
  EventInMFString[] appstrIn;  // so we don't have to get them via EAI
  EventInSFNode[] geo;         // each time we want to change their values
  EventInSFNode[] app;
  EventOutMFString[] geostrOut;
  EventOutMFString[] appstrOut;
  EventOutMFString geoselOut;
  EventOutMFString appselOut;

  boolean complete=false; // if we would send the complete state every time

  Thread receiverThread;   // to receive messages from server
  Thread aliveThread;      // periodically sends ALIVE messages to server
  boolean running=false;

  int maxmsg=15, curmsg=0; // for scrolling messages in applet drawing area
  String[] lastmsg = new String[maxmsg];

  //String hostname = "localhost";   // Domain Name of Server
  String hostname = "www.cs.uni-sb.de";   // Domain Name of Server
  int port = 3000;                 // port to register with server (TCP)

  Socket tcpsock;                
  BufferedReader tcpinput;
  PrintWriter tcpoutput;

  TextArea txt;
  
  void errout(String str) { System.out.println(str); }        // to System.out 

  protected void finalize ()
   { sendUpdate("KILL ME"); 
     // in addition we have the ALIVE-mechanism,
     // because there is no guarantee that finalize() is always executed, 
     // when a client closes its connection, eg. the machine is switched off 
    if (receiverThread!=null) receiverThread.stop();
    if (aliveThread!=null) aliveThread.stop();
   } 

  void talkmsg(String str)
   { if (curmsg==maxmsg)              // write message to applet drawing area
      { for(int i=0;i<maxmsg-1;i++) lastmsg[i]=lastmsg[i+1];
        curmsg--;
      }
    lastmsg[curmsg++]=str;
    txt.appendText("\n"+str); 
    repaint();
   }


  //public void paint(Graphics g) 
  //{ //for (int i=0; i<curmsg;i++) { g.drawString(lastmsg[i],10,12+i*12); }
  // }
  
  //  public void update(Graphics g)
  //{ g.setColor(getBackground());
  //  g.fillRect(0,0,size().width,size().height); // getSize() does not yet work
  //                                              // in Communicator 4.0.5
  //  g.setColor(getForeground());
  //  paint(g);
  //}

  public void init()
  { running=false;
    // rest of initialization is done in the start() method
    txt=new TextArea("Welcome to Miss Connectivity\n"
                  + "Please enter a nickname in the field below.\n"
                  + "Then you can type messages in the text area\n"
                  + "and send them to other visitors.\n\n\n",11,50);
    txt.setEditable(false);
    FlowLayout g=new FlowLayout(); 
    setLayout(g);
    add(txt);
    validate();
  }

  public boolean isRunning() { return running; }

  public void initx()
  { Node node;
    Node nodes[];
    browser = hackBrowser();
    // register callback with all parts of MissC
    errout("Get Statue");
    try { statue = browser.getNode("STATUE"); }
    catch (InvalidNodeException e) { errout("PROBLEMS!: " + e); }
    errout("Get Children");
    EventOutMFNode children = (EventOutMFNode) statue.getEventOut("children");
    parts=children.getValue();
    geostrIn = new EventInMFString[parts.length-1];
    appstrIn = new EventInMFString[parts.length-1];
    geo = new EventInSFNode[parts.length-1];
    app = new EventInSFNode[parts.length-1];
    if (complete)
      { geostrOut = new EventOutMFString[parts.length-1];
        appstrOut = new EventOutMFString[parts.length-1];
      }
    node = browser.getNode("GEOSELECTION"); 
    nodes= ((EventOutMFNode) node.getEventOut("choice")).getValue();
    geoselOut = (EventOutMFString) nodes[1].getEventOut("string");
    node = browser.getNode("APPSELECTION"); 
    nodes= ((EventOutMFNode) node.getEventOut("choice")).getValue();
    appselOut = (EventOutMFString) nodes[1].getEventOut("string");
    for(int i=0;i<parts.length-1;i++)  // -1 because last node is Sound { }
      { Node sensor;
        if (i==10)
	  { errout("Child");
            EventOutMFNode xchildren = (EventOutMFNode) parts[i].getEventOut("children");
            Node [] xparts = xchildren.getValue();
            errout("Sensor");
            sensor = ((EventOutSFNode) xparts[0].getEventOut("sensor")).getValue();
            parts[i]=xparts[0];
          }
         else
          { errout("Sensor (!)");
            sensor = ((EventOutSFNode) parts[i].getEventOut("sensor")).getValue();    
          }
       errout("touchTime");
       EventOutSFTime touchTime = (EventOutSFTime) parts[i].getEventOut("touchTime");
       // as a matter of fact we can also advise() the sensor inside
       // the prototype by using touchTime = (EventOutSFTime) sensor.getEventOut("touchTime");
       // but the browser will not invoke the callback method in this case ???
       touchTime.advise(this,parts[i]);
       geostrIn[i] = (EventInMFString) parts[i].getEventIn("geostr");
       appstrIn[i] = (EventInMFString) parts[i].getEventIn("appstr"); 
       geo[i] = (EventInSFNode) parts[i].getEventIn("geo");
       app[i] = (EventInSFNode) parts[i].getEventIn("app"); 
       if (complete)
        { geostrOut[i] = (EventOutMFString) parts[i].getEventOut("geostr");
          appstrOut[i] = (EventOutMFString) parts[i].getEventOut("appstr");
        }
      }

    errout("Connect");
    connect(); 
    // start threads
    // * receiverThread: receives messages from server
    // * aliveThread: periodically sends ALIVE messages to the server
    errout("Start Threads");
    receiverThread = new ReceiverThread(this);
    aliveThread = new AliveThread(this);
    running=true;

 }

  Browser hackBrowser()  // as the EAI, the browsers and the plugins are
                         // still developing we put workarounds in this function
  { Browser browser;
    boolean isNavigator=false;
    // JSObject embeds;
    // embeds=null;
    browser=null;
    errout("Trying to get handle to browser ...\n");
    // Initialize connection to Cosmo Player
    // The handbook version to get a handle to browser:
    // browser = Browser.getBrowser(this);
    // does not yet work properly in all browsers.
    // But since we use EAI's getBrowser method the following code to get 
    // a handle of the browser was provided by Cosmo's EAI FAQ to circumvent
    // a bug in netscape communicator.
    // We extended it to use LiveConnect for the Navigator
    // but got CLASSPATH problems
    // if (isNavigator==true)
    //  for the navigator we use LiveConnect
    //   { JSObject win = JSObject.getWindow(this);
    //     JSObject doc = (JSObject) win.getMember("document");
    //     embeds = (JSObject) doc.getMember("embeds");
    //  }
    for (int count = 0; count < 10; count++) {
      errout("get ...");
    //  if (isNavigator==true) browser = (Browser) embeds.getSlot(0);
    // else 
     browser = Browser.getBrowser(this);
     errout("got?");
      if (browser != null) break;
      try {Thread.sleep (500);}
      catch (InterruptedException ignored) {}
      errout("browser was null, trying again");
     }
    if (browser == null) {
      throw new Error ("Failed to get the browser after 10 tries!");
    }
    errout("Got browser\n");
    return browser;
  }
 
  public void connect()
  { InetAddress host;
    //if (running) return; //  for debugging without internet access
    // all the exception handling leads to unreadable source code!
    try { host = InetAddress.getByName(hostname); }
    catch (UnknownHostException e) { errout("Unknown host "+hostname); return; }
    if (host==null) errout("host is null");
    try { tcpsock = new Socket(host,port); }
    catch (IOException e) { errout("Could not establish connection to server!"); return; }
    try { tcpinput = new BufferedReader(new InputStreamReader(tcpsock.getInputStream())); }
    catch (IOException e) { errout("Could not open input stream from server!"); return; }
    try { tcpoutput = new PrintWriter(tcpsock.getOutputStream(),true); }
    catch (IOException e) { errout("Could not open output stream to server!"); return; }
  }

 public void sendUpdate(String upd)
  { //if (running) return; //  for debugging without internet access
    tcpoutput.println(upd);
    errout("SendUpdate:"+upd);
  }

 public String getUpdate()
  { String str;
    //if (running) return "NONE"; //  for debugging without internet access
    try { str=tcpinput.readLine(); }
    catch (IOException e) { errout("No response from server!"); str=""; }
    return str;
  }

 public void processUpdate(String str)
  { String geostr, appstr;
    int cur=4;  // ignore "UPD "
    if (str.indexOf("UPD")==0) 
     { for(int i=0;i<parts.length-1;i++)
       { errout(Integer.toString(i));
         geostr=str.substring(cur,str.indexOf(';',cur));
         cur=str.indexOf(';',cur)+1;
         appstr=str.substring(cur,str.indexOf(';',cur));
         cur=str.indexOf(';',cur)+1;
         errout(geostr+" and "+appstr);
         geostrIn[i].set1Value(0,geostr);
         appstrIn[i].set1Value(0,appstr);
         errout("set eventMFStringIns");
         Node geoNode = browser.getNode(geostr);  
         Node appNode = browser.getNode(appstr);
         errout("got nodes");
         geo[i].setValue(geoNode);
         app[i].setValue(appNode);
         errout("set eventSFNodeIns");
       }
     }
   if (str.indexOf("CHG")==0)
     { int parti;
       parti=Integer.parseInt(str.substring(cur,str.indexOf(':')));
       cur=str.indexOf(':')+1;
       geostr=str.substring(cur,cur+4); 
       cur=str.indexOf(';',cur)+1;
       appstr=str.substring(cur,cur+4);
       errout(geostr+" and "+appstr);
       geostrIn[parti].set1Value(0,geostr);
       appstrIn[parti].set1Value(0,appstr);
       errout("set eventMFStringIns");
       Node geoNode = browser.getNode(geostr);  
       Node appNode = browser.getNode(appstr);
       errout("got nodes");
       geo[parti].setValue(geoNode);
       app[parti].setValue(appNode);
       errout("set eventSFNodeIns"); 
     }
   if (str.indexOf("TLK")==0)
     { talkmsg(str.substring(cur,str.length()));
     } 
   return; 
  }

 public void start()
  { if (browser==null) initx(); // don't initialize twice
    if (receiverThread==null) receiverThread = new ReceiverThread(this);
    if (aliveThread==aliveThread) aliveThread = new AliveThread(this);

  }

 public void stop()
  { // we should not stop these thread, otherwise the
    // statue would no longer be up to date and
    // the server will remove the client entry after several seconds
    // if (receiverThread!=null) receiverThread.stop();
    // if (aliveThread!=null) aliveThread.stop();
  }

 public void callback(EventOut ev, double d, java.lang.Object obj)
  { // we know who is calling us and what type the event has,
    // but in any case, we check it:
    errout("A Call for Mr. Diehl");
    //if (ev.getType()==FieldTypes.SFTIME) // part was touched
      { // get the current settings and send them to the server
        // because this callback is executed at the same
        // time as the javascript-selection() function,
        // the changes performed by the javascript function are
	// not yet effective, so we have to access GEOSELECTION
        // and APPSELECTION also in this callback function
        String update="";
        String gstrs[]={}, astrs[]={};
         { for(int i=0;i<parts.length-1;i++)
	    { 
              if (parts[i]==(Node) obj)
	       { gstrs=geoselOut.getValue(); 
                 astrs=appselOut.getValue();
                 if (!complete) update=Integer.toString(i)+":"+gstrs[0].substring(0,4)
                                        +";"+astrs[0].substring(0,4)+";";
               }
              else
	       { if (complete)
                  { gstrs=geostrOut[i].getValue();
                    astrs=appstrOut[i].getValue();
                  }
               }
             // for some strange reason the strings we get
             // above sometimes contain a weird last chars, so we take only the first 4 chars
            if (complete) update=update+gstrs[0].substring(0,4)+";"+astrs[0].substring(0,4)+";";
	   }
          if (complete) sendUpdate("UPD "+update);
            else sendUpdate("CHG "+update);
         }
         errout("send: "+update);
      }
    return;
  }

 public void talk(String user, String msg)
  { String newline = System.getProperty("line.separator");
    int cur=0;
    while(msg.indexOf(newline,cur)!=-1)
     { sendUpdate("TLK "+user+": "
         +msg.substring(cur,msg.indexOf(newline,cur)));
       cur=msg.indexOf(newline,cur)+1;
     }
    sendUpdate("TLK "+user+": "+msg.substring(cur));
  }


} // end of class StatueApplet















