//
// Client-Script for Miss Connectivity
//
// Java Scripting and TCP/IP Testprogram
// 
// Stephan Diehl (diehl@cs.uni-sb.de), March 1998

// Java APIs
import java.applet.*;
import java.util.*;
import java.net.*;
import java.io.*;

// VRML APIs
import vrml.*;
import vrml.node.*;
import vrml.field.*;

public class StatueScript extends Script 
  implements MUTech            // for argument type of UpdateThread
{
  
  void errout(String str) { System.out.println(str); }

  Thread receiverThread;
  Thread aliveThread;
  boolean running=true;

  public boolean isRunning() { return running; }

  public void initialize()
  { connect();
    // start threads
    // * receiverThread: receives messages from server
    // * aliveThread: periodically sends ALIVE messages to the server
    receiverThread = new ReceiverThread(this);
    aliveThread = new AliveThread(this);
  }

 String hostname = "localhost";
 int port = 3000;
 Socket tcpsock;
 DataInputStream tcpinput;
 PrintStream tcpoutput;

 public void connect()
  { InetAddress host;
    try { host = InetAddress.getByName(hostname); }
    catch (UnknownHostException e)
     { errout("Unknown host "+hostname); return; }
    if (host==null) errout("host is null");
    try { tcpsock = new Socket(host,port,true); }
    catch (IOException e)
      { errout("Could not establish connection to server!"); return; }
    try { tcpinput = new DataInputStream(tcpsock.getInputStream()); }
    catch (IOException e)
      { errout("Could not open input stream from server!"); return; }
    try { tcpoutput = new PrintStream(tcpsock.getOutputStream(),true); }
    catch (IOException e)
      { errout("Could not open output stream to server!"); return; }
  }

 public void sendUpdate(String upd)
  { tcpoutput.println(upd);
  }

 public String getUpdate()
  { String str;
    try { str=tcpinput.readLine(); }
    catch (IOException e)
     { errout("No response from server!");
       str="";
     }
    return str;
  }

  // in the single user version PROTO PARTScript performs the following code:
  // url "javascript: function setchild()
  //                               { part.children[2].geometry=geoselection.choice[0];
  //                                 part.children[2].appearance=appselection.choice[0];
  //                               }"
 public void processEvent(Event e)
  { if (e.getName().equals("setchild"))
    { SFNode geometry=((SFNode) getField("part")).getField(children).getEventIn("geometry");
      SFNode appearance=getField("part").getField(children).getEventIn("appearance");
       
      sendCurrentSettings();
    }
  }

 public void sendCurrentSettings()
  { // to be implemented 
  }

}







